#ifndef lint
	static char copyright[] = "\n\
\n\
Copyright (c) 1988, 1991 by Bennet Yee.\n\
\n\
This material was developed by the above-mentioned author.  Permission to\n\
copy this software, to redistribute it, and to use it for any purpose is\n\
granted, subject to the following restrictions and understandings.\n\
\n\
1. Any copy made of this software must include this copyright notice in\n\
full.\n\
\n\
2. Users of this software agree to make their best efforts (a) to return to\n\
the above-mentioned author any improvements or extensions that they make, so\n\
that these may be included in future releases; (b) to document clearly any\n\
improvements or extensions made to this software; and (c) to inform the\n\
author of noteworthy uses of this software.  Any improvements or extensions\n\
to this software may be placed under different copyright restrictions by the\n\
author of those improvements or extensions.  That those improvements or\n\
extensions be placed under the same copyright as this software is encouraged.\n\
\n\
3. All materials containing this software or derivatives thereof must\n\
provide the contained software in source form or provide a means of\n\
obtaining the contained software in source form.\n\
\n\
4. All materials developed as a consequence of the use of this software\n\
shall duly acknowledge such use, in accordance with the usual standards of\n\
acknowledging credit in academic research.\n\
\n\
5. The author has made no warranty or representation that the operation of\n\
this software will be error-free, and the author is under no obligation to\n\
provide any services, by way of maintenance, update, or otherwise.\n\
\n\
6. In conjunction with products arising from the use of this material, there\n\
shall be no use of the names of the author, of Carnegie-Mellon University,\n\
nor of any adaptation thereof in any advertising, promotional, or sales\n\
literature without prior written consent from the author and Carnegie-Mellon\n\
University in each case.\n\
\n\
If you have questions, you can contact the author at bsy@cs.cmu.edu\n\
";
#endif /* lint */

#include <stdio.h>

int _longrun_optind = 0;
char *_longrun_optarg = 0;

int	_longrun_getopt(int	ac,
			char	**av,
			char	*opts)
{
	int		ch;
	char		*ptr, *index();
	static char	*optopt = "";

	if (_longrun_optind == 0) {
		/* reset via setting _longrun_optind to zero */
		_longrun_optind = 1; optopt = "";
		if (_longrun_optind >= ac) return EOF;
	}

	while (!*optopt) {
		if (_longrun_optind >= ac) return EOF;
		if (av[_longrun_optind][0] != '-') return EOF;
		optopt = &av[_longrun_optind][1];
		++_longrun_optind;
	}
	if ((ch = *optopt++) == '-') {
		return EOF;
	}
	if ((ptr = strchr(opts,ch)) == 0) {
		fprintf(stderr,"Illegal option character: %c, option string is %s\n",ch,opts);
		return '?';
	}
	if (ptr[1] != ':') return ch;
	if (*optopt) {
		_longrun_optarg = optopt;
		optopt = "";
		return ch;
	} else {
		if (_longrun_optind < ac) {
			_longrun_optarg = av[_longrun_optind];
			++_longrun_optind;
			return ch;
		} else {
			fprintf(stderr,"Missing arg for char %c\n",ch);
			return '?';
		}
	}
}
