#ifndef lint
	static char copyright[] = "\n\
Copyright (C) 1988, Bennet Yee, David Applegate.\n\
Copyright (C) 1994, Bennet Yee.  You may freely\n\
distribute this code as long as this notice is intact.  If you make any\n\
modifications in your distribution, you must clearly document them.  If you\n\
distribute this code or any derivative thereof, it must be provided at no\n\
charge to all parties on terms identical to those prescribed herein.\n\
All distributions must contain source code.\n\
\n\
This software is provided with absolutely no warranty.\n\
";
#endif /* lint */

/*
 * The assembler does basically the following C code.
 * Instead of the variable sp, the actual stack pointer is used.
 */
#include <stdio.h>
#include <sys/types.h>
#include <setjmp.h>

save_context(save_environ,fd,TOS,edata,esize)
jmp_buf	save_environ;
int	fd;
caddr_t	TOS;
long	edata,esize;
{
	register int	i;
	static char	*spval;
	register char	*sp;
	register long	stksz;
	
#ifdef	DEBUG
	fprintf(stderr, "save_context: setjmp\n");
#endif
	if (i = setjmp(save_environ)) return i;
#ifdef	DEBUG
	fprintf(stderr, "write(%d,%#lx,%#lx)\n",fd,edata,esize);
#endif
	if (write(fd,edata,esize) != esize) return -1;
	/*
	 * Change the assembler to grab real stack pointer instead of sp
	 */
	spval = sp;
#ifdef	DEBUG
	fprintf(stderr, "write(%d,%#lx,%#lx)\n",fd,&spval,sizeof(char **));
#endif
	if (write(fd,&spval,sizeof(char **)) != sizeof(char **)) return -1;
	stksz = TOS-spval;
#ifdef	DEBUG
	fprintf(stderr, "stk is %X\n",spval);
#endif
	if (stksz < 0) {
		stksz = -stksz;
#ifdef	DEBUG
		fprintf(stderr, "write(%d,0x%lx,0x%lx)\n",fd,TOS,stksz);
#endif
		if (write(fd,TOS,stksz) != stksz) return -1;
	} else {
#ifdef	DEBUG
		fprintf(stderr, "write(%d,0x%lx,0x%lx)\n",fd,spval,stksz);
#endif
		if (write(fd,spval,stksz) != stksz) return -1;
	}
	return 0;
}
