#ifndef lint
	static char copyright[] = "\n\
\n\
Copyright (c) 1988, 1991, 1993, 1994, 1996 by Bennet Yee.\n\
\n\
This material was developed by the above-mentioned author.  Permission to\n\
copy this software, to redistribute it, and to use it for any purpose is\n\
granted, subject to the following restrictions and understandings.\n\
\n\
1. Any copy made of this software must include this copyright notice in\n\
full.\n\
\n\
2. Users of this software agree to make their best efforts (a) to return to\n\
the above-mentioned author any improvements or extensions that they make, so\n\
that these may be included in future releases; (b) to document clearly any\n\
improvements or extensions made to this software; and (c) to inform the\n\
author of noteworthy uses of this software.  Any improvements or extensions\n\
to this software may be placed under different copyright restrictions by the\n\
author of those improvements or extensions.  That those improvements or\n\
extensions be placed under the same copyright as this software is encouraged.\n\
\n\
3. All materials containing this software or derivatives thereof must\n\
provide the contained software in source form or provide a means of\n\
obtaining the contained software in source form.\n\
\n\
4. All materials developed as a consequence of the use of this software\n\
shall duly acknowledge such use, in accordance with the usual standards of\n\
acknowledging credit in academic research.\n\
\n\
5. The author has made no warranty or representation that the operation of\n\
this software will be error-free, and the author is under no obligation to\n\
provide any services, by way of maintenance, update, or otherwise.\n\
\n\
6. In conjunction with products arising from the use of this material, there\n\
shall be no use of the names of the author, of Carnegie-Mellon University,\n\
University of California at San Diego,\n\
nor of any adaptation thereof in any advertising, promotional, or sales\n\
literature without prior written consent from the author, Carnegie-Mellon\n\
University, and University of California at San Diego in each case.\n\
\n\
If you have questions, you can contact the author at bsy@cs.cmu.edu\n\
";
#endif

#include <stdio.h>
#include <setjmp.h>
#include <sys/types.h>
#include <errno.h>
#if	mach
# define MACH	1
# include <mach.h>
# include <machine/machparam.h>
#endif

#include "save_world.h"

#define	DEBUG	1

#include <sys/param.h>
#if	!defined(linux) || !defined(i386)
# include <sys/vmparam.h>	/* x86 linux does not have vmparam.h */
#endif
#if	!defined(__SVR4)
# include <sys/dir.h>
#endif
#include <sys/user.h>

#if	__alpha && __osf__
/* header files provide useless values */
# undef	USRSTACK
# undef	USRDATA
# define	USRSTACK	0x120000000	/* ZMAGIC only */
# define	USRDATA		0x140000000	/* ZMAGIC only */
#elif	__sparc && __SVR4
/* Solaris 2.5 has different values than SunOS / Mach-on-Suns */
# undef		USRSTACK
# define	USRSTACK	0xf0000000
extern int	DYNAMIC;
# define	USRDATA		((caddr_t) &DYNAMIC)
#elif	linux && i386
# define	USRSTACK	0xc0000000
#endif

#if	defined(USRSTACK)
# define	TOS	((caddr_t) USRSTACK)
#else
# if	vax
#  ifdef UPAGES
#   define	TOS ((caddr_t) (0x80000000 - UPAGES * NBPG))
#  else
#   define	TOS ((caddr_t) (0x80000000)
#  endif
# endif
# if	ibmrt
#  if	mach
#   define	TOS ((caddr_t) (0xdffffffe))
#  else
#   define	TOS ((caddr_t) (0xdffffffe - UPAGES * NBPG))
#  endif
# endif
# if	sun
#  if	sparc
#   define	TOS ((caddr_t) (0xff000000))
#  else
#   define	TOS ((caddr_t) (0x0e000000))
#  endif
# endif
# if	mips
#  define	TOS ((caddr_t) 0x80000000-NBPG)
# endif
#endif
/* USRSTACK */

#if	__hppa
# define	getpagesize()	NBPG
# define	STACK_GROWS_UP
#endif

#if	!defined(USRDATA)
			/* hack for boxes w/o USRDATA*/
# define	BOD	((caddr_t) (~(getpagesize()-1) & (unsigned long) &environ))
#else
# define	BOD	((caddr_t) USRDATA)
#endif

#define	FLUFF	256
#define	FP_TOO	1
/* save fp registers also -- setjmp/longjmp do not nec'y save fp regs */

extern		edata;
extern char	**environ;
static jmp_buf	save_environ;
caddr_t		sbrk(), brk();
#if	FP_TOO
double		save_world_trash;
#endif

int		(*save_world_hook)() = 0, (*restore_world_hook)() = 0;

/* use up the fp registers, so user ones are forced onto stack */
save_world(int	fd,
	   int	retval,
	   int	mode)
#if	FP_TOO
{
	register double	f0, f1, f2, f3, f4, f5, f6, f7,
			f8, f9, f10,f11,f12,f13,f14,f15,
			f16,f17,f18,f19,f20,f21,f22,f23,
			f24,f25,f26,f27,f28,f29,f30,f31;
	int		rv;

	/* we should never get a fp overflow here, since ints are too small */
	f0 = fd;
	if (f0 == 0.0) f0 = 1.0;
	f1 = f0 * f0;
	f2 = f1 * f0;
	f3 = f2 * f0;
	f4 = f3 / f0;
	f5 = f4 * f0;
	f6 = f5 / f0;
	f7 = f6 * f0;
	f8 = f7 / f0;
	f9 = f8 * f0;
	f10 = f9 / f0;
	f11 = f10 * f0;
	f12 = f11 / f0;
	f13 = f12 * f0;
	f14 = f13 / f0;
	f15 = f14 * f0;
	f16 = f15 / f0;
	f17 = f16 * f0;
	f18 = f17 / f0;
	f19 = f18 * f0;
	f20 = f19 / f0;
	f21 = f20 * f0;
	f22 = f21 / f0;
	f23 = f22 * f0;
	f24 = f23 / f0;
	f25 = f24 * f0;
	f26 = f25 / f0;
	f27 = f26 * f0;
	f28 = f27 / f0;
	f29 = f28 * f0;
	f30 = f29 / f0;
	f31 = f30 * f0;
	save_world_trash = f31;
	rv = save_world_no_fp(fd,retval,mode);
	/*
	 * we use the fp regs again here, to make sure
	 * that the compiler wouldn't have restored them
	 * to the user's values prior to calling save_world_no_fp.
	 */
	f0 = f31;
	if (f0 == 0.0) f0 = 1.0;
	f1 = f0 * f0;
	f2 = f1 * f0;
	f3 = f2 * f0;
	f4 = f3 / f0;
	f5 = f4 * f0;
	f6 = f5 / f0;
	f7 = f6 * f0;
	f8 = f7 / f0;
	f9 = f8 * f0;
	f10 = f9 / f0;
	f11 = f10 * f0;
	f12 = f11 / f0;
	f13 = f12 * f0;
	f14 = f13 / f0;
	f15 = f14 * f0;
	f16 = f15 / f0;
	f17 = f16 * f0;
	f18 = f17 / f0;
	f19 = f18 * f0;
	f20 = f19 / f0;
	f21 = f20 * f0;
	f22 = f21 / f0;
	f23 = f22 * f0;
	f24 = f23 / f0;
	f25 = f24 * f0;
	f26 = f25 / f0;
	f27 = f26 * f0;
	f28 = f27 / f0;
	f29 = f28 * f0;
	f30 = f29 / f0;
	f31 = f30 * f0;

	return rv;
}
save_world_no_fp(int	fd,
		 int	retval,
		 int	mode)
#endif
{
	static int	jmpretval;
	static caddr_t	top_mem, data_start;
	long		obuf[3];

	if (save_world_hook) (*save_world_hook)();

	obuf[0] = retval;
	switch (mode) {
	case SAVE_UNINIT:
		data_start = (caddr_t) &edata;
		break;
	case SAVE_ALL:
		data_start = BOD;
		break;
	}
	obuf[1] = (long) data_start;
	top_mem = sbrk(0);
	obuf[2] = (long) top_mem;
#if	DEBUG
	fprintf(stderr,"TOS is %#lx, mode is %d\n",TOS, mode);
	fprintf(stderr,"write(%d,%#lx,%#x)\n",fd,(char *) obuf,sizeof obuf);
#endif
	if (write(fd,(char *) obuf,sizeof obuf) != sizeof obuf)
		return 0;
#if	DEBUG
	fprintf(stderr,"edata = %#lx\n",(long) &edata);
	fprintf(stderr,"BOD = %#lx\n",(long) BOD);
	fprintf(stderr,"&environ = %#lx\n",(long) &environ);
	fprintf(stderr,"wrote retval = %#x\n",retval);
	fprintf(stderr,"wrote data_start = %#lx\n",(long) data_start);
	fprintf(stderr,"wrote top_mem = %#lx\n",(long) top_mem);
	fprintf(stderr,"save_environ = %lx\n",(long) save_environ);
	fprintf(stderr,"fd = %x, TOS = %lx, data_start = %lx\n",fd,(long) TOS,(long) data_start);
	fprintf(stderr,"top_mem-data_start = %lx\n",top_mem - (long) data_start);
#endif
	jmpretval = save_context(save_environ,fd,(long) TOS,(long) data_start,top_mem-(long) data_start);
#if	DEBUG
	printf("save_context returned %x, errno = %d\n",jmpretval,errno);
#endif
	switch (jmpretval) {
	case -1:
		return 0;
	case 0:
#if	DEBUG
	fprintf(stderr,"data_start = %lx, save_environ = %lx\n",data_start,save_environ);
	{
		int i;
		for (i = 0; i < 16; i++) printf("%d: %lx\n",i,save_environ[i]);
	}
#endif
		if (fsync(fd) == -1) return 0;
		return 1;
	default:
		if (restore_world_hook) (*restore_world_hook)();
		return jmpretval;
	}
}
restore_world(int	fd,
	      int	other_ret)
{
	caddr_t	top_mem, mem_ptr, data_start;
	long	ibuf[3], retval;
	int	tmp;

#if	DEBUG
	fprintf(stderr,"Entered restore_world\n");
#endif
	if (read(fd,(char *) ibuf,sizeof ibuf) != sizeof ibuf)
		return 0;
	retval = ibuf[0];
	data_start = (caddr_t) ibuf[1];
	top_mem = (caddr_t) ibuf[2];
#if	DEBUG
	fprintf(stderr,"read retval = %#x\n",retval);
	fprintf(stderr,"read data_start = %#lx\n",data_start);
	fprintf(stderr,"read top_mem = %#lx\n",top_mem);
#endif
	if (brk(top_mem) != 0)
		return 0;
#if	DEBUG
	fprintf(stderr,"brk(%#lx) succeeded\n",top_mem);
	fprintf(stderr,"data_start = %lx, save_environ = %lx\n",data_start,save_environ);
	fprintf(stderr,"Before:\n");
	{
		int i;
		for (i = 0; i < 16; i++) printf("%d: %lx\n",i,save_environ[i]);
	}
	fprintf(stderr,"read mem starting at %#lx, len %#lx\n",data_start,top_mem-data_start);
#endif
	if ((tmp = read(fd,(char *)data_start,top_mem-data_start)) != top_mem-data_start) {
#if	DEBUG
		fprintf(stderr,"Got %d bytes\n",tmp);
#endif
		return 0;
	}
#if	DEBUG
	fprintf(stderr,"Got %d bytes\n",tmp);
	fprintf(stderr,"After:\n");
	{
		int i;
		for (i = 0; i < 16; i++) printf("%d: %lx\n",i,save_environ[i]);
	}
#endif
	if (read(fd,(char *) &mem_ptr,sizeof mem_ptr) != sizeof mem_ptr)
		return 0;
#if	DEBUG
		fprintf(stderr,"read addr of mem_ptr = %#lx\n",mem_ptr);
#endif
	validatestack(mem_ptr,retval|other_ret,fd);
	/* NOTREACHED */
}

validatestack(caddr_t	mem_ptr,
	      int	retval,
	      int	fd)
{
#if	DEBUG
	int size;
#endif
	char	space[1024];

#if	lint
	space[0]=0;
#endif
#if	defined(STACK_GROWS_UP)
	if (mem_ptr+FLUFF > (caddr_t) &mem_ptr)
		validatestack(mem_ptr,retval,fd);
#else
	if (mem_ptr-FLUFF < (caddr_t) &mem_ptr)
		validatestack(mem_ptr,retval,fd);
#endif
#if	DEBUG
# if	defined(STACK_GROWS_UP)
	if ((size = read(fd,(char *) TOS,mem_ptr-TOS)) != mem_ptr-TOS) {
		fprintf(stderr,"read in stack of only %lx instead of %lx\n",size,mem_ptr-TOS);
		fprintf(stderr,"TOS is %lx, mem_ptr is %lx\n",TOS,mem_ptr);
	}
# else
	if ((size = read(fd,(char *) mem_ptr,TOS-mem_ptr)) != TOS-mem_ptr) {
		fprintf(stderr,"read in stack of only %lx instead of %lx\n",size,TOS-mem_ptr);
		fprintf(stderr,"TOS is %X, mem_ptr is %lx\n",TOS,mem_ptr);
	}
# endif
#else
# if	defined(STACK_GROWS_UP)
	if (read(fd,(char *) TOS,mem_ptr-TOS) != mem_ptr-TOS)
# else
	if (read(fd,(char *) mem_ptr,TOS-mem_ptr) != TOS-mem_ptr)
# endif
	{
		/*       1234567891123456789212345678931 */
		write(2,"save_world: stack read failure\n",31);
		abort();
	}
#endif
#if	DEBUG
	fprintf(stderr,"read stkmem starting at %#lx, len %#lx\n",mem_ptr,TOS-mem_ptr);
	{
		int i;
		for (i = 0; i < 16; i++) printf("%d: %lx\n",i,save_environ[i]);
	}
#endif
#if	vax
	mylongjmp(save_environ,retval);
#else
# if	ibmrt || sun || sparc || mips || i386 || __hppa || (__alpha && __osf__)
	longjmp(save_environ,retval);
# else
	What kind of machine am I getting build on anyway?  Tell me!
# endif
#endif
	/* guard against build errors */
	abort();
	/* NOTREACHED */
}
